package Source;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Victor
 */
import java.awt.Color;
import java.util.Random;

public class EntityPoint implements java.io.Serializable {

    public double x;
    public double y;
    public Color color = Color.BLACK;
    private static Random r = new Random();
    public int cluster;
    public static double wa;
    public static double wb;
    public static double wc;
    public double weibull;

    public EntityPoint() {
        this.weibull = weibull();
    }

    public EntityPoint(double x, double y) {

        this.x = x;
        this.y = y;
        this.weibull = weibull();
    }

    public EntityPoint(int range) {
        this.x = range * r.nextDouble();
        this.y = range * r.nextDouble();
        this.weibull = weibull();
    }

    public static double distance(EntityPoint p1, EntityPoint p2) {
        return Math.sqrt(Math.pow(p1.getX() - p2.getX(), 2) + Math.pow(p1.getY() - p2.getY(), 2));
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public void setX(double x) {
        this.x = x;
    }

    public void setY(double y) {
        this.y = y;
    }

    public EntityPoint offset(double xo, double yo) {
        EntityPoint op = new EntityPoint(this.x, this.y);
        op.x += xo;
        op.y += yo;
        return op;
    }

    public static void setWeibull(double a, double b, double c) {
        wa = a;//shape parameter - alpha from Mathworld
        wb = b;//scale parameter - beta from Mathworld
        wc = c;//location parameter
    }

    private static double weibull() {
        double p = r.nextDouble();
        double x = wb * (Math.pow(Math.log(1 / (1 - p)), 1 / wa)) + wc;
        return (double) Math.round(x * 10) / 10;
    }
}
