package Source;


import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.ArrayList;
import java.util.Random;
import javax.imageio.ImageIO;
import javax.swing.JProgressBar;

public class ImageUtil {

    public static void writeImage(PointList[] pointList, File file, int size, JProgressBar progress) {
        progress.setString(null);

        BufferedImage bi = new BufferedImage(size, size, BufferedImage.TYPE_INT_RGB);
        Graphics2D g = bi.createGraphics();
        g.setBackground(Color.white);
        g.drawRect(0, 0, size, size);
        Random r = new Random();
        for (int i = 0; i < pointList.length; i++) {
            g.setColor(new Color(r.nextInt(255), r.nextInt(255), r.nextInt(255)));
            if ((i * 50) % pointList.length == 0) {
                progress.setValue((i * 100) / pointList.length);
                progress.paint(progress.getGraphics());
            }
            for (int j = 0; j < pointList[i].list.size(); j++) {
                EntityPoint p = pointList[i].list.get(j);
                g.drawLine((int) Math.floor(p.x), (int) Math.floor(p.y), (int) Math.floor(p.x), (int) Math.floor(p.y));
            }
        }

        try {
            ImageIO.write(bi, "png", file);
            System.out.println(file.getAbsolutePath());
            progress.setValue(100);
            progress.setString("Done!");
            progress.paint(progress.getGraphics());


        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
